﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DelphiNostalgia
{
  public partial class FormMain : Form
  {
    private bool info;

    public FormMain()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
      propertyGrid.BrowsableAttributes =
        new System.ComponentModel.AttributeCollection(
          new Attribute[] { new CategoryAttribute("Nostalgia") });
      TypeDescriptor.AddAttributes(typeof(StringCollection), new EditorAttribute("System.Windows.Forms.Design.StringCollectionEditor, System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a", typeof(System.Drawing.Design.UITypeEditor)));
    }

    private void tabControl_SelectedIndexChanged(object sender, EventArgs e)
    {
      propertyGrid.SelectedObject = tabControl.SelectedTab.Controls[0];
      buttonRefresh.Visible = tabControl.SelectedTab == tabPageRadioGroup;
    }

    private void buttonRefresh_Click(object sender, EventArgs e)
    {
      if (!info)
      {
        MessageBox.Show("This button calls workaround for PropertyGrid that cannot update radio buttons at runtime after changing the Items property. When you edit Items under IDE or assign the new items collection from your code directly, everything works fine.", "Delphi Nostalgia", MessageBoxButtons.OK, MessageBoxIcon.Information);
        info = true;
      }
      radioGroup.UpdateButtons();
    }

    private void FormMain_Shown(object sender, EventArgs e)
    {
      radioGroup.UpdateButtons();
		}
  }
}
