﻿using System;
using System.Drawing;
using System.Windows.Forms;
using Greatis.Nostalgia;

namespace HotKeysDemo
{
  public partial class FormMain : Form
  {
    public FormMain()
    {
      InitializeComponent();
      Font = SystemFonts.MessageBoxFont;
    }

    private string KeyString(Keys key, bool Control, bool Alt, bool Shift, bool Win)
    {
      string result = key.ToString();
      if (Win) result = "Win+" + result;
      if (Shift) result = "Shift+" + result;
      if (Alt) result = "Alt+" + result;
      if (Control) result = "Control+" + result;
      return result;
    }

    private void buttonRegister_Click(object sender, EventArgs e)
    {
      HotKey hk = new HotKey();
      if (hk.ShowDialog() == DialogResult.OK)
      {
        int i = hotKeys.RegisterKey(hk.Key, hk.Control, hk.Alt, hk.Shift, hk.Win);
        if (i > 0)
          listBoxHotKeys.Items.Add(i.ToString() + "  " + KeyString(hk.Key, hk.Control, hk.Alt, hk.Shift, hk.Win));
      }
    }

    private void hotKeys_HotKeyPressed(object sender, HotKeyEventArgs e)
    {
      MessageBox.Show(KeyString(e.Key, e.Control, e.Alt, e.Shift, e.Win));
    }

    private void listBoxHotKeys_SelectedIndexChanged(object sender, EventArgs e)
    {
      buttonUnregister.Enabled = listBoxHotKeys.SelectedItem != null;
    }

    private void buttonUnregister_Click(object sender, EventArgs e)
    {
      string s = (string)listBoxHotKeys.SelectedItem;
      s = s.Substring(0, s.IndexOf(" "));
      if (hotKeys.UnregisterKey(int.Parse(s)))
      {
        listBoxHotKeys.Items.Remove(listBoxHotKeys.SelectedItem);
      }
    }
  }
}
